VERSION 5.00
Object = "{4B762E7F-D72C-4CA3-8B78-726EC3551AD9}#1.0#0"; "MbtOE.ocx"
Begin VB.Form frmOE
   Caption         =   "Order Entry"
   ClientHeight    =   2820
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7395
   Icon            =   "frmOE.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   ScaleHeight     =   2820
   ScaleWidth      =   7395
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame fraRule
      Height          =   30
      Left            =   120
      TabIndex        =   3
      Top             =   460
      Width           =   6975
   End
   Begin VB.TextBox txtSymbol
      Height          =   320
      Left            =   840
      TabIndex        =   0
      Top             =   80
      Width           =   1215
   End
   Begin MBTOELib.MbtSmOE MbtSmOECtl
      Height          =   1815
      Left            =   120
      TabIndex        =   1
      Top             =   960
      Width           =   7095
      _Version        =   65536
      _ExtentX        =   12515
      _ExtentY        =   3201
      _StockProps     =   2
      Caption         =   "Order Entry (No Accounts) "
      Template        =   5
   End
   Begin VB.Label Label1
      Caption         =   "Symbol:"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Width           =   855
   End
End
Attribute VB_Name = "frmOE"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'***********************************************************
' By using this material you agree to comply with the terms
' governing the MBTI systems and with the MBTI Site Terms and
' Conditions available for view at http://www.mbtrading.com/
' Copyright 2003 MB Trading, Inc. ALL RIGHTS RESERVED.
'***********************************************************
'
Option Explicit

Private Sub Form_Load()
    Show
    txtSymbol.SetFocus

    ' Add autocompletion feature to symbol textbox to demonstrate the MbtAutoComplete object
    Dim ac As MbtAutoComplete
    Set ac = frmMain.ComMgr.AutoComplete(acSymbols)

    ' You *should* respect the user's autocompletion options in preferences and only
    ' use the ACO_AUTOAPPEND flag if True as shown
    Dim dwOptions As Long
    If frmMain.ComMgr.Prefs.SymbolAutoComplete Then dwOptions = ACO_AUTOAPPEND
    dwOptions = dwOptions Or ACO_AUTOSUGGEST Or ACO_UPDOWNKEYDROPSLIST
    ac.Attach txtSymbol.hwnd, dwOptions ' This will associate our form's textbox with the autocompletion object
    Set ac = Nothing

    Dim lOeHeight As Long
    Dim lOeWidth As Long
    lOeHeight = MbtSmOECtl.SuggestedClientHeight
    lOeWidth = MbtSmOECtl.SuggestedClientWidth
    Call MbtSmOECtl_OnSuggestedClientSizeChanged(lOeWidth, lOeHeight)
    Call MbtSmOECtl_OnAccountChanged(MbtSmOECtl.Account)

    SerializeForm Me, False
End Sub

Private Sub Form_Unload(Cancel As Integer)
    SerializeForm Me, True
End Sub
Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    Debug.Print "Form_KeyDown KeyCode=" & KeyCode
    If KeyCode = 13 Then
        ' Enter key pressed...load up new symbol and let OE control get further input
        MbtSmOECtl.Symbol = txtSymbol.Text
        MbtSmOECtl.TabIn
    End If
End Sub

Private Sub MbtSmOECtl_OnAccountChanged(ByVal pNewAcct As Object)
    ' This event is fired in cases where the user has multiple accts, and has changed this OE's acct.
    ' Here, you probably want to update your titlebar etc to reflect the currently loaded acct
    Debug.Print "MbtSmOECtl_OnAccountChanged"
    Me.Caption = "Order Entry [" & FormatAccount(pNewAcct) & "]"
End Sub

Private Sub MbtSmOECtl_OnSuggestedClientSizeChanged(ByVal lNewWidth As Long, ByVal lNewHeight As Long)
    ' This event is fired when the OE's template has changed, and the control would
    ' like us to resize our frame to fully fit its content.
    ' Note: the values passed are in pixels so we need to convert to twips
    Debug.Print "MbtSmOECtl_OnSuggestedClientSizeChanged"

    Dim lRule As Long
    Dim lNonClientX As Long
    Dim lNonClientY As Long

    lRule = fraRule.Top + fraRule.Height + 30
    MbtSmOECtl.Move 0, lRule, lNewWidth * Screen.TwipsPerPixelX, lNewHeight * Screen.TwipsPerPixelY

    fraRule.Width = MbtSmOECtl.Width - 100

    lNonClientX = Width - ScaleWidth
    lNonClientY = height - ScaleHeight

    Me.Move Left, Top, MbtSmOECtl.Width + (lNonClientX * 2), MbtSmOECtl.Top + MbtSmOECtl.Height + lNonClientY
End Sub

Private Sub MbtSmOECtl_OnTabbingOut(pbAccept As Boolean)
    Debug.Print "MbtSmOECtl_OnTabbingOut"
    ' Tab/Shift-Tab was pressed during the last/first OE control respectively.
    ' This gives parent an opportunity to switch focus to one of its own controls
    txtSymbol.SetFocus
    txtSymbol.SelText = txtSymbol.Text
    pbAccept = True
End Sub

Private Sub txtSymbol_KeyPress(KeyAscii As Integer)
    If KeyAscii = 13 Then
        KeyAscii = 0 ' Eat the Enter key
    Else
        KeyAscii = Asc(UCase(Chr(KeyAscii)))
    End If
End Sub
