VERSION 5.00
Object = "{BDC217C8-ED16-11CD-956C-0000C04E4C0A}#1.1#0"; "TABCTL32.OCX"
Begin VB.Form frmQuoteTest 
   Caption         =   "Quote Test"
   ClientHeight    =   4845
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   11745
   LinkTopic       =   "Form1"
   ScaleHeight     =   4845
   ScaleWidth      =   11745
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picData 
      BorderStyle     =   0  'None
      Height          =   3015
      Left            =   120
      ScaleHeight     =   3015
      ScaleWidth      =   11535
      TabIndex        =   11
      Top             =   1680
      Width           =   11535
      Begin VB.CommandButton cmdReset 
         Caption         =   "Reset Cache"
         Height          =   255
         Left            =   9720
         TabIndex        =   16
         Top             =   120
         Width           =   1215
      End
      Begin VB.ListBox lstData 
         Height          =   2700
         IntegralHeight  =   0   'False
         Left            =   1800
         TabIndex        =   13
         Top             =   360
         Width           =   9735
      End
      Begin VB.ListBox lstAdvised 
         Height          =   2700
         IntegralHeight  =   0   'False
         Left            =   0
         Sorted          =   -1  'True
         TabIndex        =   12
         TabStop         =   0   'False
         Top             =   360
         Width           =   1815
      End
      Begin VB.Label lblAdvised 
         Caption         =   "Advised:"
         Height          =   375
         Left            =   0
         TabIndex        =   15
         Top             =   120
         Width           =   735
      End
      Begin VB.Label lblData 
         Caption         =   "Data Received:"
         Height          =   255
         Left            =   1800
         TabIndex        =   14
         Top             =   120
         Width           =   1335
      End
   End
   Begin TabDlg.SSTab SSTab1 
      Height          =   3495
      Left            =   60
      TabIndex        =   10
      Top             =   1320
      Width           =   11655
      _ExtentX        =   20558
      _ExtentY        =   6165
      _Version        =   393216
      Style           =   1
      Tabs            =   5
      Tab             =   4
      TabsPerRow      =   5
      TabHeight       =   520
      TabCaption(0)   =   "Level 1"
      TabPicture(0)   =   "frmQuoteTest.frx":0000
      Tab(0).ControlEnabled=   0   'False
      Tab(0).ControlCount=   0
      TabCaption(1)   =   "Level 2"
      TabPicture(1)   =   "frmQuoteTest.frx":001C
      Tab(1).ControlEnabled=   0   'False
      Tab(1).ControlCount=   0
      TabCaption(2)   =   "Options"
      TabPicture(2)   =   "frmQuoteTest.frx":0038
      Tab(2).ControlEnabled=   0   'False
      Tab(2).ControlCount=   0
      TabCaption(3)   =   "Time and Sales"
      TabPicture(3)   =   "frmQuoteTest.frx":0054
      Tab(3).ControlEnabled=   0   'False
      Tab(3).ControlCount=   0
      TabCaption(4)   =   "All"
      TabPicture(4)   =   "frmQuoteTest.frx":0070
      Tab(4).ControlEnabled=   -1  'True
      Tab(4).ControlCount=   0
   End
   Begin VB.Frame Frame1 
      Caption         =   "Service"
      Height          =   975
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   9135
      Begin VB.CheckBox chkService 
         Caption         =   "Time and Sales"
         Height          =   255
         Index           =   3
         Left            =   2760
         TabIndex        =   6
         Top             =   480
         Width           =   1575
      End
      Begin VB.CheckBox chkService 
         Caption         =   "Options Chains"
         Height          =   255
         Index           =   2
         Left            =   2760
         TabIndex        =   5
         Top             =   240
         Width           =   1455
      End
      Begin VB.CheckBox chkService 
         Caption         =   "Level 2"
         Height          =   255
         Index           =   1
         Left            =   1800
         TabIndex        =   4
         Top             =   480
         Width           =   1095
      End
      Begin VB.CheckBox chkService 
         Caption         =   "Level 1"
         Height          =   255
         Index           =   0
         Left            =   1800
         TabIndex        =   3
         Top             =   240
         Width           =   1095
      End
      Begin VB.CommandButton cmdUnadviseAll 
         Caption         =   "Unadvise All"
         Height          =   375
         Left            =   7560
         TabIndex        =   9
         Top             =   360
         Width           =   1335
      End
      Begin VB.TextBox txtSymbol 
         Height          =   285
         Left            =   240
         TabIndex        =   2
         Top             =   480
         Width           =   1215
      End
      Begin VB.CommandButton cmdAdvise 
         Caption         =   "Advise"
         Height          =   375
         Left            =   4440
         TabIndex        =   7
         Top             =   360
         Width           =   1215
      End
      Begin VB.CommandButton cmdUnadvise 
         Caption         =   "Unadvise"
         Height          =   375
         Left            =   5880
         TabIndex        =   8
         Top             =   360
         Width           =   1455
      End
      Begin VB.Label Label1 
         Caption         =   "Symbol:"
         Height          =   255
         Left            =   240
         TabIndex        =   1
         Top             =   240
         Width           =   615
      End
   End
End
Attribute VB_Name = "frmQuoteTest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'***********************************************************
' By using this material you agree to comply with the terms
' governing the MBTI systems and with the MBTI Site Terms and
' Conditions available for view at http://www.mbtrading.com/
' Copyright 2003 MB Trading, Inc. ALL RIGHTS RESERVED.
'***********************************************************
'
Option Explicit
Implements IMbtQuotesNotify ' quotes callback interface
Private Quotes As MbtQuotes
Private m_aData As CDataArray ' Stash for log data
Private m_dictAdvised(0 To 3) As Dictionary
Private iNum As Integer

' These first 4 enums correspond to:
' - the tab in the tab control for filtering of a particular feed's data
' - the index to the m_colAdvised collection where the list of symbols currently advised for each service is stashed.
' - the chkService checkbox control array which can be checked or unchecked to advise or unadvise each
Private Enum enumServiceIndexes
    siLevel1 = 0
    siLevel2 = 1
    siOptions = 2
    siTimeAndSales = 3
    siAll = 4
End Enum

Private m_asLogPrefixes(0 To 3) As String
Private m_listboxMargin As Single
Private m_nSelTab As Integer

Private Sub Form_Load()
    Set Quotes = frmMain.ComMgr.Quotes ' Stash local reference to the quotes object (to save typing :))

   iNum = 0
   Set m_aData = New CDataArray
    Dim i As Integer
    For i = LBound(m_dictAdvised) To UBound(m_dictAdvised)
        Set m_dictAdvised(i) = New Dictionary
    Next i

    ' Hack to marry each service's checkbox with the proper flags needed for Advise/UnadviseSymbol method
    chkService(siLevel1).Tag = qsfLevelOne
    chkService(siLevel2).Tag = qsfLevelTwo
    chkService(siTimeAndSales).Tag = qsfTimeAndSales
    chkService(siOptions).Tag = qsfOptions

    'Map of prefixes to be appended to log data when the "All" tab is active
    m_asLogPrefixes(siLevel1) = "Level1: "
    m_asLogPrefixes(siLevel2) = "Level2: "
    m_asLogPrefixes(siOptions) = "Options: "
    m_asLogPrefixes(siTimeAndSales) = "Time&Sales: "

    m_listboxMargin = picData.height - lstAdvised.height

    m_nSelTab = siLevel1
    SSTab1.Tab = m_nSelTab
    Repopulate m_nSelTab
    chkService(siLevel1).Value = vbChecked
    SerializeForm Me, False
End Sub

Private Sub Form_Resize()
    Dim margin As Single
    Dim height As Single

    margin = SSTab1.Left
    height = ScaleHeight - SSTab1.Top - margin
    SSTab1.Move margin, SSTab1.Top, ScaleWidth - margin * 2, height
    cmdReset.Left = SSTab1.Left + SSTab1.Width - cmdReset.Width - 600

    margin = picData.Left
    height = ScaleHeight - picData.Top - margin
    picData.Move margin, picData.Top, ScaleWidth - margin * 2, height
End Sub

Private Sub Form_Unload(Cancel As Integer)
    ' Important! Stop ALL services for ALL symbols that were subscribed using this
    ' callback interface (ie "Me"). This is the same thing as manually doing ]
    ' UnadviseSymbol xxx, flags for every symbol and service that was ever subscribed to
    Quotes.UnadviseAll Me

    Dim i As Integer
    Set m_aData = Nothing
    For i = LBound(m_dictAdvised) To UBound(m_dictAdvised)
        Set m_dictAdvised(i) = Nothing
    Next i

    Set Quotes = Nothing
    SerializeForm Me, True
End Sub

Private Sub lstAdvised_Click()
    Dim i As Integer
    i = lstAdvised.ListIndex
    If i <> -1 Then txtSymbol.Text = lstAdvised.List(i)
End Sub

Private Sub txtSymbol_KeyPress(KeyAscii As Integer)
    ' Force symbols to all caps
    KeyAscii = Asc(UCase$(Chr$(KeyAscii)))
End Sub

Private Sub cmdAdvise_Click()
    DoAdviseUnadvise True
End Sub

Private Sub cmdUnadvise_Click()
    DoAdviseUnadvise False
End Sub

Private Sub cmdUnadviseAll_Click()
    ' Stop all quotes for all services and symbols
    Quotes.UnadviseAll Me

    lstAdvised.Clear

    Dim i As Integer
    For i = LBound(m_dictAdvised) To UBound(m_dictAdvised)
        m_dictAdvised(i).RemoveAll
    Next i
End Sub

Private Sub DoAdviseUnadvise(bAdvise As Boolean)
    Dim sSymbol As String
    Dim lSvcFlags As Long
    sSymbol = Trim(txtSymbol)
    If Len(sSymbol) Then
        Dim i As Integer
        Dim bSel As Boolean
        Dim bAction As Boolean
        For i = 0 To 3
            ' Advise quotes for each service whose checkbox is checked. The checkbox indexes happen to be the same
            If chkService(i).Value Then
                If bAdvise Then
                    If Not m_dictAdvised(i).Exists(sSymbol) Then
                        m_dictAdvised(i).Add sSymbol, True

                        ' "Or" in the service flags for this particular service that we stashed in the check control's tag (in Form_Load).
                        ' By doing it this way, we can advise/unadvise all services for this symbol in one shot
                        lSvcFlags = lSvcFlags Or CLng(chkService(i).Tag)

                        ' If this service is the selected tab, add the symbol to the "Advised" listbox too
                        If m_nSelTab = i Then
                            lstAdvised.AddItem sSymbol
                        End If
                        bAction = True
                    End If
                Else
                    ' Unadvise request...check if it's in our list already for this service
                    If m_dictAdvised(i).Exists(sSymbol) Then
                        bAction = True
                        lSvcFlags = lSvcFlags Or CLng(chkService(i).Tag)

                        ' If this service is the selected tab, remove the symbol from the "Advised" listbox
                        Dim j As Integer
                        If m_nSelTab = i Then
                            For j = 0 To lstAdvised.ListCount
                                If lstAdvised.List(j) = sSymbol Then
                                    lstAdvised.RemoveItem j
                                    Exit For
                                End If
                            Next j
                        End If
                        m_dictAdvised(i).Remove sSymbol
                    End If
                End If
                bSel = True
            End If
        Next i
        Dim sAction As String
        sAction = IIf(bAdvise, "Advise", "Unadvise")
        If Not bSel Then
            MsgBox "No service(s) selected to " & sAction
        Else
            If bAction Then
                ' We have at least one valid service for which we haven't already advised or unadvised
                If bAdvise Then
                    ' Quotes will start flowing until UnadviseSymbol (with this same symbol/service flag(s))
                    ' or UnadviseAll is called. It is your responsibility to keep track of which symbols
                    ' are subscribed; ie if you forget to unadvise them, bandwidth will be wasted because
                    ' the server will still 'think' a client is interested in these symbols and continue sending
                    ' quotes. This is why we stashed symbols above in a local dictionary
                    Quotes.AdviseSymbol Me, sSymbol, lSvcFlags
                Else
                    Quotes.UnadviseSymbol Me, sSymbol, lSvcFlags
                End If
            Else
                MsgBox "Symbol already " & sAction & "d for all checked services."
            End If
        End If
    End If
    ' Note, advises / unadvises on a symbol are cumulative. Thus, you can call AdviseSymbol with only the qsfLevelOne flag
    ' one time, and then call it again separately with qsfLevelTwo. The second request will not negate the first.
    ' You can also of course advise them in one shot as we've done here by OR'ing together the flags.
End Sub

Private Sub picData_Resize()
    On Error Resume Next

    Dim bAdvisedStuffVisible As Boolean
    bAdvisedStuffVisible = lblAdvised.Visible

    Dim listboxTop As Single
    Dim listboxHeight As Single
    listboxTop = lstAdvised.Top
    listboxHeight = picData.height - m_listboxMargin

    Dim dataleft As Single
    If bAdvisedStuffVisible Then
        dataleft = lstAdvised.Width + 40
        lstAdvised.Move 0, listboxTop, lstAdvised.Width, listboxHeight
    End If

    lstData.Move dataleft, lstData.Top, picData.Width - dataleft, listboxHeight
    lblData.Left = dataleft
End Sub

Private Sub SSTab1_Click(PreviousTab As Integer)
    Debug.Print "Click"
    Dim NewTab As Integer
    NewTab = SSTab1.Tab
    If NewTab <> m_nSelTab Then
        Repopulate NewTab
    End If

    Dim i As Integer
    ' Auto-check the services checkbox for the currently selected tab, or all checkboxes if the All tab is sel'd
    For i = 0 To 3
        If NewTab <> siAll Then
            chkService(i).Value = IIf(i = NewTab, vbChecked, vbUnchecked)
        End If
    Next i
End Sub

Private Sub Repopulate(NewTab As Integer)
    m_nSelTab = NewTab
    lstAdvised.Clear
    lstData.Clear
    Dim i As Long
    Dim dataItem As Data

    SendMessage lstData.hwnd, WM_SETREDRAW, 0, ByVal 0 'Reduce flicker and improve insert performance
    For i = 0 To m_aData.UpperBound
        dataItem = m_aData.Item(i)
        AddToList dataItem
    Next i
    SendMessage lstData.hwnd, WM_SETREDRAW, 1, ByVal 0

    'Hide the advised symbols combo and make data listbox take up entire width when in ALL mode, and vice versa when not
    Dim bShowAdvisedStuff As Boolean
    bShowAdvisedStuff = IIf(NewTab = siAll, False, True)

    lstAdvised.Visible = bShowAdvisedStuff
    lblAdvised.Visible = bShowAdvisedStuff

    If NewTab < siAll Then
        ' Populate symbols combo with list of symbols that are advised for the selected tab's corresponding svc
        Dim sSymbol As Variant
        For Each sSymbol In m_dictAdvised(NewTab)
            lstAdvised.AddItem sSymbol
        Next
    End If

    picData_Resize
End Sub

Private Sub cmdReset_Click()
    ' Clear all cached quote data and reset data listbox
    m_aData.RemoveAll
    lstData.Clear
End Sub

Private Sub Log(sData As String, nService As Integer)
    Dim dataItem As Data
    dataItem.sData = sData
    dataItem.nService = nService
    If lstData.ListCount > 15 Then
      lstData.RemoveItem (0)
      m_aData.RemoveAll ' this doesn't have a RemoveItem method, so let's just trash the whole thing. Works. Phil.
    End If
    m_aData.Add dataItem
    AddToList dataItem
End Sub

Private Sub AddToList(dataItem As Data)
    If m_nSelTab = siAll Then
        ' We add all records, but prefix them with the service type
        lstData.AddItem m_asLogPrefixes(dataItem.nService) & dataItem.sData
    ElseIf dataItem.nService = m_nSelTab Then
        ' Only add it to listbox if the correct tab is currently selected
        lstData.AddItem dataItem.sData
    End If
    lstData.ListIndex = lstData.ListCount - 1
End Sub

'----------------------------------------------------------------------------------------
' IMbtQuotesNotify interface callbacks... all four must be implemented by the parent
' class(even if you are not using all services). These handlers will be called when data
' is received for a symbol for which AdviseSymbol has been called.
' Note: if you set a breakpoint in the IDE, it does NOT freeze these events because VB
' internally spins a separate thread to deal with the UI and/or direct callbacks. You will
' therefore still see quotes appearing to arrive...

Private Sub IMbtQuotesNotify_OnQuoteData(pQuote As MBTQUOTELib.QUOTERECORD)
    ' Here, you would devise your own plan of what to do with this raw quote data. You might
    ' stash them in some sort of collection of your own objects, keyed to the symbol; or
    ' put them directly into some sort of grid etc. For illustrative purposes here, we are
    ' just going to concatenate a string representation of the underlying data and add it
    ' to an array cache which we use to populate our list controls. Kind of inefficient,
    ' and a memory hog, but it works for this purpose.
    Dim sData As String, sDte As String, sTme As String, oDte As Date
    oDte = pQuote.UTCDateTime
    sDte = Right("0" & Month(oDte), 2) & "/" & Right("0" & Month(oDte), 2) & "/" & Right("0" & Month(oDte), 2)
    sTme = Right("0" & Hour(oDte), 2) & ":" & Right("0" & Minute(oDte), 2) & ":" & Right("0" & Second(oDte), 2)
    

    iNum = iNum + 1
    sData = CStr(iNum) & ". sym=" & pQuote.bstrSymbol & ", L=" & pQuote.dLast & ", B=" & pQuote.dBid & _
            ", A=" & pQuote.dAsk & ", BSz=" & pQuote.lBidSize & ", ASz=" & pQuote.lAskSize & _
            ", Cl=" & pQuote.dPrevClose & ", H=" & pQuote.dHigh & ", L=" & pQuote.dLow & _
            ", Sz=" & pQuote.lLastSize & ", V=" & pQuote.lVolume & ", tick=" & pQuote.tick & _
            ", O=" & pQuote.dOpen & ", Time=" & sTme & ", Date=" & sDte & _
            ", Mkt=" & pQuote.bstrMarket & ", CoName=" & pQuote.bstrCompany & ", flags=" & pQuote.lFlags & _
            ", margmult=" & pQuote.dMarginMult & ", CSz=" & pQuote.lContractSize & _
            ", StrkPrc=" & pQuote.dStrikePrice & ", putcall=" & pQuote.PutCall & _
            ", expmo=" & pQuote.lExpMonth & ", expyr=" & pQuote.lExpYear & ", underlier=" & pQuote.bstrUnderlier

    Log sData, siLevel1
End Sub

Private Sub IMbtQuotesNotify_OnLevel2Data(pRec As MBTQUOTELib.LEVEL2RECORD)
    Dim sData As String, sDte As String, sTme As String, oTme As Date
    oTme = pRec.UTCTime
    sTme = Right("0" & Hour(oTme), 2) & ":" & Right("0" & Minute(oTme), 2) & ":" & Right("0" & Second(oTme), 2)

    iNum = iNum + 1
    sData = CStr(iNum) & ". sym=" & pRec.bstrSymbol & ", MMID=" & pRec.bstrMMID & ", Prc=" & pRec.dPrice & _
            ", Sz=" & pRec.lSize & ", side=" & pRec.side & ", Time=" & sTme & _
            ", Src=" & pRec.bstrSource & ", Closed=" & pRec.bClosed

    Log sData, siLevel2
End Sub

Private Sub IMbtQuotesNotify_OnOptionsData(pRec As MBTQUOTELib.OPTIONSRECORD)
    Dim sData As String, sDte As String, sTme As String, oDte As Date
    oDte = pRec.UTCDateTime
    sDte = Right("0" & Month(oDte), 2) & "/" & Right("0" & Month(oDte), 2) & "/" & Right("0" & Month(oDte), 2)
    sTme = Right("0" & Hour(oDte), 2) & ":" & Right("0" & Minute(oDte), 2) & ":" & Right("0" & Second(oDte), 2)

    ' Note this is very similar to a Level1 record
    iNum = iNum + 1
    sData = CStr(iNum) & ". sym=" & pRec.bstrSymbol & ", underlier=" & pRec.bstrUnderlier & ", Strike=" & pRec.dStrikePrice & _
            ", expmo=" & pRec.lExpMonth & ", expyr=" & pRec.lExpYear & ", L=" & pRec.dLast & _
            ", B=" & pRec.dBid & ", A=" & pRec.dAsk & ", BSz=" & pRec.lBidSize & ", ASz=" & pRec.lAskSize & _
            ", Cl=" & pRec.dPrevClose & ", H=" & pRec.dHigh & ", L=" & pRec.dLow & _
            ", Sz=" & pRec.lLastSize & ", V=" & pRec.lVolume & ", tick=" & pRec.tick & _
            ", O=" & pRec.dOpen & ", Time=" & sTme & ", Date=" & sDte & _
            ", OpenInt=" & pRec.lOpenInterest & ", putcall=" & pRec.PutCall

    Log sData, siOptions
End Sub

Private Sub IMbtQuotesNotify_OnTSData(pRec As MBTQUOTELib.TSRECORD)
    Dim sData As String, sDte As String, sTme As String, oTme As Date
    oTme = pRec.UTCTime
    sTme = Right("0" & Hour(oTme), 2) & ":" & Right("0" & Minute(oTme), 2) & ":" & Right("0" & Second(oTme), 2)

    iNum = iNum + 1
    sData = CStr(iNum) & ". sym=" & pRec.bstrSymbol & ", exch=" & pRec.bstrExchange & ", Sz=" & pRec.lSize & _
            ", Prc=" & pRec.dPrice & ", type=" & pRec.lType & ", Time=" & sTme

    Log sData, siTimeAndSales
End Sub


