Attribute VB_Name = "modUtil"
'***********************************************************
' By using this material you agree to comply with the terms
' governing the MBTI systems and with the MBTI Site Terms and
' Conditions available for view at http://www.mbtrading.com/
' Copyright 2003 MB Trading, Inc. ALL RIGHTS RESERVED.
'***********************************************************
'
Option Explicit

Public Type Data
    nService As Integer
    sData As String
End Type

Public Const WM_SETREDRAW = &HB

Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long


' FormatAccount()
'
' For use in creating window captions, Returns the semi-delimited account
' string if non-null, otherwise returns "No Accounts" or "All Accounts"
' depending on the value of optional flag
'
Public Function FormatAccount(acct As MbtAccount, Optional bAllowAll As Boolean = False) As String
    Dim sAcct As String

    If acct Is Nothing Then
        If bAllowAll Then
            sAcct = "All Accounts"
        Else
            sAcct = "No Accounts"
       End If
    Else
        sAcct = acct.SemiDelimited
    End If
    FormatAccount = sAcct
End Function

'
' SerializeForm()
'
' Saves and restores form's size and position to/from registry
'
Public Sub SerializeForm(frm As Form, bSave As Boolean)
    Dim sPos As String
    If bSave Then
'        sPos = Format(frm.Left) & "," & Format(frm.Top) & "," & Format(frm.Width) & "," & Format(frm.height)
'        SaveSetting App.EXEName, frm.Name, "Pos", sPos
    Else
'        sPos = GetSetting(App.EXEName, frm.Name, "Pos", "")
        If Len(sPos) Then
            Dim aFields() As String
            aFields = Split(sPos, ",")
            If UBound(aFields) = 3 Then
                Dim i As Integer
                For i = 0 To 3
                    If Not IsNumeric(aFields(i)) Then
                       Exit Sub ' Bad data!
                    End If
                Next i
                frm.Move CSng(aFields(0)), CSng(aFields(1)), CSng(aFields(2)), CSng(aFields(3))
            End If
        End If
    End If
End Sub

