/***********************************************************
 By using this material you agree to comply with the terms
 governing the MBTI systems and with the MBTI Site Terms and
 Conditions available for view at http://www.mbtrading.com/
 Copyright 2003 MB Trading, Inc. ALL RIGHTS RESERVED.
************************************************************/

// NavOCqDlg.cpp : implementation file

#include "stdafx.h"
#include "NavOCq.h"
#include "NavOCqDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNavOCqDlg dialog

IMPLEMENT_DYNAMIC(CNavOCqDlg, CDialog);

CNavOCqDlg::CNavOCqDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNavOCqDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CNavOCqDlg)
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

CNavOCqDlg::~CNavOCqDlg()
{
}

void CNavOCqDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNavOCqDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CNavOCqDlg, CDialog)
	//{{AFX_MSG_MAP(CNavOCqDlg)
	ON_WM_CLOSE()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNavOCqDlg message handlers

BOOL CNavOCqDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	// always on top!
	SetWindowPos (&wndTopMost, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOSIZE);
	HDC hDC;
	hDC = ::CreateCompatibleDC (NULL);
	SetBkColor(hDC, RGB(40,80,120));

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CNavOCqDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CNavOCqDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CNavOCqDlg::OnClose() 
{
	if (CanExit())
		CDialog::OnClose();
}

void CNavOCqDlg::OnOK() 
{
	if (CanExit())
		CDialog::OnOK();
}

void CNavOCqDlg::OnCancel() 
{
	if (CanExit())
		CDialog::OnCancel();
}

BOOL CNavOCqDlg::CanExit()
{
	return TRUE;
}
