VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CDataArray"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'***********************************************************
' By using this material you agree to comply with the terms
' governing the MBTI systems and with the MBTI Site Terms and
' Conditions available for view at http://www.mbtrading.com/
' Copyright 2003 MB Trading, Inc. ALL RIGHTS RESERVED.
'***********************************************************
'
Option Explicit
Private m_array() As Data
Private m_nSize As Long
Private m_nRealSize As Long
Private m_nGrowBy As Long

' Quick and dirty auto-growing string array (yes it's missing tons of features, but it works for this purpose)

Private Sub Class_Initialize()
    m_nGrowBy = 10
    Grow
End Sub

Private Sub Grow()
    m_nRealSize = m_nRealSize + m_nGrowBy
    ReDim Preserve m_array(0 To m_nRealSize - 1)
End Sub

Friend Property Get UpperBound() As Long
    UpperBound = m_nSize - 1
End Property

Friend Property Get LowerBound() As Long
    LowerBound = 0
End Property

Friend Property Get Size() As Long
    Size = m_nSize
End Property

Friend Property Get RealSize() As Long
    RealSize = m_nRealSize
End Property

Friend Sub Add(dataItem As Data)
    If m_nSize + 1 > m_nRealSize Then Grow
    m_array(m_nSize) = dataItem
    m_nSize = m_nSize + 1
End Sub

Friend Sub RemoveAll()
    ReDim m_array(0)
    m_nSize = 0
    m_nRealSize = 0
End Sub

Friend Property Get Item(index As Long) As Data
    Item = m_array(index)
End Property

