VERSION 5.00
Object = "{3AF128DE-C93E-409B-8402-964D81E36F93}#1.0#0"; "MbtGrids.ocx"
Begin VB.Form frmLevel2 
   Caption         =   "Level II"
   ClientHeight    =   4905
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8790
   Icon            =   "frmLevel2.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   4905
   ScaleWidth      =   8790
   StartUpPosition =   3  'Windows Default
   Begin MBTGRIDSLib.MbtL2 MbtL2Ctl 
      Height          =   4695
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   8655
      _Version        =   65536
      _ExtentX        =   15266
      _ExtentY        =   8281
      _StockProps     =   2
      Caption         =   "Level II -  (No Accounts) "
      OETemplate      =   0
      OEHeight        =   101
      QQHeight        =   78
      TickerWidth     =   125
   End
End
Attribute VB_Name = "frmLevel2"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'***********************************************************
' By using this material you agree to comply with the terms
' governing the MBTI systems and with the MBTI Site Terms and
' Conditions available for view at http://www.mbtrading.com/
' Copyright 2003 MB Trading, Inc. ALL RIGHTS RESERVED.
'***********************************************************
'
Option Explicit

Implements IMbtQuotesNotify ' Quotes callback interface
Private m_sCompany As String
Private m_sSymbol As String

Private Sub Form_Load()
    m_sSymbol = MbtL2Ctl.Symbol
    m_sCompany = m_sSymbol
    MbtL2Ctl.QQHeight = 85
    MbtL2Ctl.OEHeight = 100
    MbtL2Ctl.TickerWidth = 105
    SetCaption
    SerializeForm Me, False
End Sub

Private Sub Form_Unload(Cancel As Integer)
    ' This is VERY important. You MUST make sure this form's quote callback
    ' interface has been released. Failure to do so will result in unexplained crashes!
    frmMain.ComMgr.Quotes.UnadviseAll Me
    SerializeForm Me, True
End Sub

Private Sub Form_Resize()
   Dim sW As Single, sH As Single
   sW = ScaleWidth
   sH = ScaleHeight
   MbtL2Ctl.Move 0, 0, sW, sH
End Sub

Private Sub SetCaption()
    Dim sCompany As String
    If Len(m_sCompany) Then
        sCompany = "- " & m_sCompany & " "
    End If
    Caption = "Level II " & sCompany & "[" & FormatAccount(MbtL2Ctl.Account) & "]"
End Sub

Private Sub MbtL2Ctl_OnAccountChanged(ByVal pNewAcct As Object)
    ' This event is fired in cases where the user has multiple accts, and has changed the contained OE's acct.
    ' Here, you probably want to update your titlebar etc to reflect the currently loaded acct
    Debug.Print "MbtL2Ctl_OnAccountChanged"

    SetCaption
End Sub

Private Sub MbtL2Ctl_OnSymbolChanged(ByVal Symbol As String)
    ' Fired when user has entered a new symbol in the L1 area
    Debug.Print "MbtL2Ctl_OnSymbolChanged"

    m_sSymbol = Symbol
    m_sCompany = m_sSymbol ' We'll default the company name to just the symbol in case we can't get a quote

    SetCaption

    ' To demonstrate the quote api, we will temporarily advise a L1 quote for this newly entered
    ' symbol just until we get a company name for it, after which we will unadvise
    If Len(Symbol) Then
        ' Register our callback interface to receive quotes for the new symbol
        frmMain.ComMgr.Quotes.AdviseSymbol Me, Symbol, qsfLevelOne
    End If
End Sub

'-------------------------------------------------------------------------------
' IMbtQuotesNotify callback interface...
' Even though we are only interested in getting level one quotes in this module,
' we still have to implement all of these callback handlers since we are implementing
' an entire interface.

Private Sub IMbtQuotesNotify_OnQuoteData(pQuote As MBTQUOTELib.QUOTERECORD)
    If pQuote.bstrSymbol = m_sSymbol Then
        m_sCompany = pQuote.bstrCompany
        'We're done receiving all quotes so tell quotes component to release our callback interface
        frmMain.ComMgr.Quotes.UnadviseAll Me
        SetCaption
    End If
End Sub

Private Sub IMbtQuotesNotify_OnLevel2Data(pRec As MBTQUOTELib.LEVEL2RECORD)

End Sub

Private Sub IMbtQuotesNotify_OnOptionsData(pRec As MBTQUOTELib.OPTIONSRECORD)

End Sub

Private Sub IMbtQuotesNotify_OnTSData(pRec As MBTQUOTELib.TSRECORD)

End Sub

