VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "NavVB"
   ClientHeight    =   4695
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   1785
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4695
   ScaleWidth      =   1785
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdFX 
      Caption         =   "Forex"
      Height          =   375
      Left            =   0
      TabIndex        =   12
      Top             =   4350
      Width           =   1815
   End
   Begin VB.CommandButton cmdObserveEvents 
      Caption         =   "Trace Events"
      Height          =   375
      Left            =   0
      TabIndex        =   11
      Top             =   3980
      Width           =   1815
   End
   Begin VB.CommandButton cmdQuoteTest 
      Caption         =   "Quote Test"
      Height          =   375
      Left            =   0
      TabIndex        =   10
      Top             =   3600
      Width           =   1815
   End
   Begin VB.CommandButton cmdOE 
      Caption         =   "Order Entry"
      Height          =   360
      Left            =   0
      TabIndex        =   9
      Top             =   3240
      Width           =   1815
   End
   Begin VB.CommandButton cmdQuickQuote 
      Caption         =   "QuickQuote"
      Height          =   360
      Left            =   0
      TabIndex        =   8
      Top             =   2880
      Width           =   1815
   End
   Begin VB.CommandButton cmdAlerts 
      Caption         =   "Alerts"
      Height          =   360
      Left            =   0
      TabIndex        =   1
      Top             =   360
      Width           =   1815
   End
   Begin VB.CommandButton cmdOrderbook 
      Caption         =   "Orderbook"
      Height          =   360
      Left            =   0
      TabIndex        =   5
      Top             =   1800
      Width           =   1815
   End
   Begin VB.CommandButton cmdPositions 
      Caption         =   "Positions"
      Height          =   360
      Left            =   0
      TabIndex        =   6
      Top             =   2160
      Width           =   1815
   End
   Begin VB.CommandButton cmdBalances 
      Caption         =   "Balances"
      Height          =   360
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   1815
   End
   Begin VB.CommandButton cmdWatchlist 
      Caption         =   "Watchlist"
      Height          =   360
      Left            =   0
      TabIndex        =   7
      Top             =   2520
      Width           =   1815
   End
   Begin VB.CommandButton cmdOpenOrders 
      Caption         =   "Open Orders"
      Height          =   360
      Left            =   0
      TabIndex        =   3
      Top             =   1080
      Width           =   1815
   End
   Begin VB.CommandButton cmdOptChain 
      Caption         =   "Options Chain"
      Height          =   360
      Left            =   0
      TabIndex        =   4
      Top             =   1440
      Width           =   1815
   End
   Begin VB.CommandButton cmdLevel2 
      Caption         =   "Level II"
      Height          =   360
      Left            =   0
      TabIndex        =   2
      Top             =   720
      Width           =   1815
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'***********************************************************
' By using this material you agree to comply with the terms
' governing the MBTI systems and with the MBTI Site Terms and
' Conditions available for view at http://www.mbtrading.com/
' Copyright 2003 MB Trading, Inc. ALL RIGHTS RESERVED.
'***********************************************************
'
Option Explicit

' This is a singleton -- only ONE such object may be used application-wide
' It must be created at app start and killed (set to Nothing) at shutdown.
' Your main form's Load and Unload events respectively are good places
Public WithEvents ComMgr As MbtComMgr
Attribute ComMgr.VB_VarHelpID = -1

Private m_bLoggedIn As Boolean

Private Sub Form_Load()
    ' Create main shared Navigator communications manager object
    Set ComMgr = New MbtComMgr
'   Set frmOETraceEvents.ComMgr = New frmOETraceEvents.MbtComMgr
   Set frmOETraceEvents.OrderClient = ComMgr.OrderClient
   frmOETraceEvents.OrderClient.OnDemandMode = True
    CheckLoggedIn
    SerializeForm Me, False
'    frmOETraceEvents.Show
End Sub

Private Sub Form_Unload(Cancel As Integer)
    SerializeForm Me, True
    
    ' Important: we need to kill any open forms including our controls BEFORE
    ' releasing our reference to ComMgr!
    Dim f As Form
    For Each f In Forms
        Unload f
    Next
    
    ' At this point, by releasing our reference to ComMgr, the object will clean itself
    ' up and handle logging out from Quotes, Orders, and Permissions. It will also at
    ' this time persist all preferences to server.
    Set ComMgr = Nothing
End Sub

Public Function CheckLoggedIn() As Boolean
    ' For *any* of the MbtNav activex controls to be useable, successful login MUST
    ' first take place. You should either do login at your app's start, or do it in
    ' a function such as this that is called before showing any forms which use our
    ' controls.
    If m_bLoggedIn Then
        CheckLoggedIn = True
    Else
        ' By supplying empty login/pw parameters here, Navigator's login dialog
        ' will automatically prompt the user.
        m_bLoggedIn = ComMgr.DoLogin(HOSTVER_SDKTEST, "", "", "")
        CheckLoggedIn = m_bLoggedIn
    End If
End Function

Private Sub cmdLevel2_Click()
    If CheckLoggedIn Then frmLevel2.Show
End Sub
Private Sub cmdOpenOrders_Click()
    If CheckLoggedIn Then frmOpenOrders.Show
End Sub

Private Sub cmdOptChain_Click()
    If CheckLoggedIn Then frmOptChain.Show
End Sub

Private Sub cmdWatchlist_Click()
    If CheckLoggedIn Then frmWatchlist.Show
End Sub

Private Sub cmdBalances_Click()
    If CheckLoggedIn Then frmBalances.Show
End Sub

Private Sub cmdPositions_Click()
    If CheckLoggedIn Then frmPositions.Show
End Sub

Private Sub cmdOrderbook_Click()
    If CheckLoggedIn Then frmOrderBook.Show
End Sub

Private Sub cmdAlerts_Click()
    If CheckLoggedIn Then frmAlerts.Show
End Sub

Private Sub cmdOE_Click()
    If CheckLoggedIn Then frmOE.Show
End Sub

Private Sub cmdFX_Click()
    If CheckLoggedIn Then frmFX.Show
End Sub

Private Sub cmdQuickQuote_Click()
    If CheckLoggedIn Then frmQuickQuote.Show
End Sub

Private Sub cmdQuoteTest_Click()
    If CheckLoggedIn Then frmQuoteTest.Show
End Sub

Private Sub cmdObserveEvents_Click()
    If CheckLoggedIn Then frmOETraceEvents.Show
End Sub

'----------------------------------------------------------------------------------------
' ComMgr event handlers

Private Sub ComMgr_OnCriticalShutdown()
    ' During this event, you *must* consider Nav components to no longer be useable.
    ' You should either shut your app down altogether, or at least remove all Mbt controls at this time
    Debug.Print "ComMgr_OnCriticalShutdown"
    Unload Me
End Sub

Private Sub ComMgr_OnHealthUpdate(ByVal index As MBTCOMLib.enumServerIndex, ByVal state As MBTQUOTELib.enumConnectionState)
    ' This is called from time to time to give you current status of various server connections
    Debug.Print "ComMgr_OnHealthUpdate: server=" & index & " state=" & state
End Sub
