VERSION 5.00
Object = "{4B762E7F-D72C-4CA3-8B78-726EC3551AD9}#2.0#0"; "MbtOE.ocx"
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "RICHTX32.OCX"
Begin VB.Form frmOETraceEvents 
   ClientHeight    =   8025
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7470
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   ScaleHeight     =   8025
   ScaleWidth      =   7470
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdInsertDelimiter 
      Caption         =   "Insert De&limiter"
      Height          =   375
      Left            =   2280
      TabIndex        =   5
      Top             =   60
      Width           =   1455
   End
   Begin VB.CommandButton cmdClearRTB 
      Caption         =   "&Clear Log"
      Height          =   375
      Left            =   3840
      TabIndex        =   4
      Top             =   60
      Width           =   1455
   End
   Begin RichTextLib.RichTextBox rtb1 
      Height          =   3255
      Left            =   360
      TabIndex        =   3
      Top             =   2160
      Width           =   5775
      _ExtentX        =   10186
      _ExtentY        =   5741
      _Version        =   393217
      ScrollBars      =   3
      TextRTF         =   $"frmOEEvents.frx":0000
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Lucida Console"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
   Begin VB.TextBox txtSymbol 
      Height          =   320
      Left            =   840
      TabIndex        =   0
      Top             =   60
      Width           =   1215
   End
   Begin MBTOELib.MbtSmOE MbtSmOECtl2 
      Height          =   735
      Left            =   0
      TabIndex        =   1
      Top             =   480
      Width           =   2535
      _Version        =   131072
      _ExtentX        =   4471
      _ExtentY        =   1296
      _StockProps     =   2
      Caption         =   "Order Entry (No Accounts) "
      Template        =   1
   End
   Begin VB.Label Label1 
      Caption         =   "Symbol:"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Width           =   855
   End
End
Attribute VB_Name = "frmOETraceEvents"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'***********************************************************
' By using this material you agree to comply with the terms
' governing the MBTI systems and with the MBTI Site Terms and
' Conditions available for view at http://www.mbtrading.com/
' Copyright 2003 MB Trading, Inc. ALL RIGHTS RESERVED.
'***********************************************************
'
Option Explicit
Public WithEvents ComMgr As MbtComMgr
Attribute ComMgr.VB_VarHelpID = -1
Public WithEvents OrderClient As MbtOrderClient
Attribute OrderClient.VB_VarHelpID = -1

Private Function add_pOrd(ByVal pOrd As MBTORDERSLib.IMbtOpenOrder)
   Dim tv As String
   tv = IIf(pOrd.BuySell = VALUE_BUY, "Buy", _
      IIf(pOrd.BuySell = VALUE_SELL, "Sell", _
      IIf(pOrd.BuySell = VALUE_SELLSHT, "Short", _
   "???")))
   tv = tv & " " & FormatNumber(pOrd.Quantity, 0)
   tv = tv & " " & pOrd.Symbol
   tv = tv & " at " & FormatNumber(pOrd.Price, 2)
   tv = tv & " ON:" & pOrd.OrderNumber
   tv = tv & " OT:" & pOrd.Token
   tv = tv & " fld:" & pOrd.SharesFilled
   tv = tv & " Evt:" & pOrd.CurrentEvent & vbCrLf
   add_pOrd = tv
End Function

Private Function add_pHist(ByVal pHist As MBTORDERSLib.IMbtOrderHistory)
   Dim tv As String
   tv = IIf(pHist.BuySell = VALUE_BUY, "Buy", _
      IIf(pHist.BuySell = VALUE_SELL, "Sell", _
      IIf(pHist.BuySell = VALUE_SELLSHT, "Short", _
   "???")))
   tv = tv & " " & FormatNumber(pHist.Quantity, 0)
   tv = tv & " " & pHist.Symbol
   tv = tv & " at " & FormatNumber(pHist.Price, 2)
   tv = tv & " ON:" & pHist.OrderNumber
   tv = tv & " OT:" & pHist.Token
   tv = tv & " Evt:" & pHist.Event & vbCrLf
   add_pHist = tv
End Function

Private Function add_pAcct(ByVal pAcct As MBTORDERSLib.IMbtAccount)
   Dim tv As String
   tv = "[" & pAcct.Account & "], "
   tv = tv & IIf(pAcct.AcctType = ACCT_TYPE_CASH, "CASH", _
      IIf(pAcct.AcctType = ACCT_TYPE_MGN, "MARGIN", "OTHER")) & " acct.,"
   tv = tv & " BP: " & FormatNumber(pAcct.CurrentBP, 2)
   tv = tv & " EQ: " & FormatNumber(pAcct.CurrentEquity, 2) & vbCrLf
   add_pAcct = tv
End Function

Private Function add_lErrorCode(ByVal lErrorCode As Long)
   Dim tv As String
   tv = "lErrorCode: [" & FormatNumber(lErrorCode) & "]" & vbCrLf
   add_lErrorCode = tv
End Function

Private Function add_pPos(ByVal pPos As MBTORDERSLib.IMbtPosition)
   Dim tv As String
   tv = "[" & pPos.Account.Account & "], "
   tv = tv & IIf(pPos.Account.AcctType = ACCT_TYPE_CASH, "CASH", _
      IIf(pPos.Account.AcctType = ACCT_TYPE_MGN, "MARGIN", "OTHER")) & " acct.,"
   tv = tv & " pendingBuyShares: " & FormatNumber(pPos.PendingBuyShares, 0)
   tv = tv & " pendingSellShares: " & FormatNumber(pPos.PendingSellShares, 0)
   tv = tv & " of " & pPos.Symbol
   tv = tv & " PNL: " & FormatNumber(pPos.RealizedPNL, 2)
   tv = tv & " remaining: " & FormatNumber(pPos.CloseableShares, 0) & vbCrLf
   add_pPos = tv
End Function

Private Sub cmdInsertDelimiter_Click()
   rtb1.Text = rtb1.Text & "---" & Replace(LCase(Time()), " ", "") & _
      "-------------------------------------------------------------------------------------------" & vbCrLf
End Sub

Private Sub MbtSmOECtl2_OnTemplateChanged(ByVal NewTemplate As Long)
   ResizeUs
End Sub

Private Sub OrderClient_OnAcknowledge(ByVal pOrd As MBTORDERSLib.IMbtOpenOrder)
   rtb1.Text = rtb1.Text & "pOrd  _OnAcknowledge   " & add_pOrd(pOrd)
End Sub

Private Sub OrderClient_OnBalanceUpdate(ByVal pAcct As MBTORDERSLib.IMbtAccount)
   rtb1.Text = rtb1.Text & "pAcct _OnBalanceUpdate " & add_pAcct(pAcct)
End Sub

Private Sub OrderClient_OnCancel(ByVal pOrd As MBTORDERSLib.IMbtOpenOrder)
   rtb1.Text = rtb1.Text & "pOrd  _OnCancel        " & add_pOrd(pOrd)
End Sub

Private Sub OrderClient_OnCancelReject(ByVal pOrd As MBTORDERSLib.IMbtOpenOrder)
   rtb1.Text = rtb1.Text & "pOrd  _OnCancelReject  " & add_pOrd(pOrd)
End Sub

Private Sub OrderClient_OnClose(ByVal lErrorCode As Long)
   rtb1.Text = rtb1.Text & "_OnClose         " & add_lErrorCode(lErrorCode)
End Sub

Private Sub OrderClient_OnConnect(ByVal lErrorCode As Long)
   rtb1.Text = rtb1.Text & "_OnConnect       " & add_lErrorCode(lErrorCode)
End Sub

Private Sub OrderClient_OnDefaultAccountChanged(ByVal pAcct As MBTORDERSLib.IMbtAccount)
   rtb1.Text = rtb1.Text & "pAcct _OnDfltAcctChngd " & add_pAcct(pAcct)
End Sub

Private Sub OrderClient_OnExecute(ByVal pOrd As MBTORDERSLib.IMbtOpenOrder)
   rtb1.Text = rtb1.Text & "pOrd  _OnExecute       " & add_pOrd(pOrd)
End Sub

Private Sub OrderClient_OnHistoryAdded(ByVal pHist As MBTORDERSLib.IMbtOrderHistory)
   rtb1.Text = rtb1.Text & "pHist _OnHistoryAdded  " & add_pHist(pHist)
End Sub

Private Sub OrderClient_OnLogonSucceed()
   Dim oAct As MbtAccount, oActs As MbtAccounts
   Set oActs = OrderClient.Accounts
   For Each oAct In oActs
      oAct.Load
   Next
   rtb1.Text = rtb1.Text & "-------------- _OnLogonSucceed --------------" & vbCrLf
End Sub

Private Sub OrderClient_OnPositionAdded(ByVal pPos As MBTORDERSLib.IMbtPosition)
   rtb1.Text = rtb1.Text & "pPos  _OnPositionAdded " & add_pPos(pPos)
End Sub

Private Sub OrderClient_OnPositionUpdated(ByVal pPos As MBTORDERSLib.IMbtPosition)
   rtb1.Text = rtb1.Text & "pPos  _OnPositonUpdatd " & add_pPos(pPos)
End Sub

Private Sub OrderClient_OnReject(ByVal pOrd As MBTORDERSLib.IMbtOpenOrder)
   rtb1.Text = rtb1.Text & "pOrd  _OnReject        " & add_pOrd(pOrd)
End Sub

Private Sub OrderClient_OnRemove(ByVal pOrd As MBTORDERSLib.IMbtOpenOrder)
   rtb1.Text = rtb1.Text & "pOrd  _OnRemove        " & add_pOrd(pOrd)
End Sub

Private Sub OrderClient_OnSubmit(ByVal pOrd As MBTORDERSLib.IMbtOpenOrder)
   rtb1.Text = rtb1.Text & "pOrd  _OnSubmit        " & add_pOrd(pOrd)
End Sub

Private Sub OrderClient_OnSyncAccounts(ByVal pAcct As MBTORDERSLib.IMbtAccount)
   rtb1.Text = rtb1.Text & "_OnSyncAccounts  " & add_pAcct(pAcct)
End Sub

Private Sub Form_Load()
   Me.Show
   txtSymbol.SetFocus

   ' Add autocompletion feature to symbol textbox to demonstrate the MbtAutoComplete object
   Dim ac As MbtAutoComplete
   Set ac = frmMain.ComMgr.AutoComplete(acSymbols)
'   Set ComMgr = New MbtComMgr
'   Set OrderClient = ComMgr.OrderClient
'   OrderClient.OnDemandMode = True

   ' You *should* respect the user's autocompletion options in preferences and only
   ' use the ACO_AUTOAPPEND flag if True as shown
   Dim dwOptions As Long
   If frmMain.ComMgr.Prefs.SymbolAutoComplete Then dwOptions = ACO_AUTOAPPEND
   dwOptions = dwOptions Or ACO_AUTOSUGGEST Or ACO_UPDOWNKEYDROPSLIST
   ac.Attach txtSymbol.hwnd, dwOptions ' This will associate our form's textbox with the autocompletion object
   Set ac = Nothing
   
   SerializeForm Me, False
   rtb1.Text = ""
   MbtSmOECtl2.Template = 1
   MbtSmOECtl2.Left = 1
   MbtSmOECtl2.Top = 450
   MbtSmOECtl2.Width = MbtSmOECtl2.SuggestedClientWidth * Screen.TwipsPerPixelX
   MbtSmOECtl2.height = MbtSmOECtl2.SuggestedClientHeight * Screen.TwipsPerPixelY
   ResizeUs
End Sub

Private Sub Form_Unload(Cancel As Integer)
    SerializeForm Me, True
End Sub

Private Sub cmdClearRTB_Click()
   rtb1.Text = ""
End Sub

Private Sub Form_Resize()
   ResizeUs
End Sub

Private Sub ResizeUs()
   ' Tidy things
   Dim padd As Long
   padd = 500
   rtb1.Width = frmOETraceEvents.Width - (Screen.TwipsPerPixelX * 1)
   rtb1.height = frmOETraceEvents.height - (Screen.TwipsPerPixelY * 1) + padd + 1
   rtb1.Left = 0
   rtb1.Top = (MbtSmOECtl2.SuggestedClientHeight * Screen.TwipsPerPixelY) + padd
   If frmOETraceEvents.Width < ((MbtSmOECtl2.SuggestedClientWidth + 2) * Screen.TwipsPerPixelY) Then
      frmOETraceEvents.Width = ((MbtSmOECtl2.SuggestedClientWidth + 2) * Screen.TwipsPerPixelY)
   End If
   MbtSmOECtl2.Width = MbtSmOECtl2.SuggestedClientWidth * Screen.TwipsPerPixelX
   MbtSmOECtl2.height = MbtSmOECtl2.SuggestedClientHeight * Screen.TwipsPerPixelY
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
   If KeyCode = 13 Then
      ' Enter key pressed...load up new symbol and let OE control get further input
      MbtSmOECtl2.Symbol = txtSymbol.Text
      MbtSmOECtl2.TabIn
   End If
End Sub

Private Sub MbtSmOECtl2_OnAccountChanged(ByVal pNewAcct As Object)
    ' This event is fired in cases where the user has multiple accts, and has changed this OE's acct.
    ' Here, you probably want to update your titlebar etc to reflect the currently loaded acct
    Debug.Print "MbtSmOECtl2_OnAccountChanged"
    Me.Caption = "Order Entry [" & FormatAccount(pNewAcct) & "]"
End Sub

Private Sub MbtSmOECtl2_OnTabbingOut(pbAccept As Boolean)
    Debug.Print "MbtSmOECtl2_OnTabbingOut"
    ' Tab/Shift-Tab was pressed during the last/first OE control respectively.
    ' This gives parent an opportunity to switch focus to one of its own controls
    txtSymbol.SetFocus
    txtSymbol.SelText = txtSymbol.Text
    pbAccept = True
End Sub

Private Sub txtSymbol_KeyPress(KeyAscii As Integer)
    If KeyAscii = 13 Then
        KeyAscii = 0 ' Eat the Enter key
    Else
        KeyAscii = Asc(UCase(Chr(KeyAscii)))
    End If
End Sub

