VERSION 5.00
Object = "{3AF128DE-C93E-409B-8402-964D81E36F93}#1.0#0"; "MbtGrids.ocx"
Begin VB.Form frmWatchlist 
   Caption         =   "Watchlist"
   ClientHeight    =   3420
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8130
   Icon            =   "frmWatchlist.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   3420
   ScaleWidth      =   8130
   StartUpPosition =   3  'Windows Default
   Begin MBTGRIDSLib.MbtWatch MbtWatchCtl 
      Height          =   3135
      Left            =   0
      TabIndex        =   0
      Top             =   240
      Width           =   7935
      _Version        =   65536
      _ExtentX        =   13996
      _ExtentY        =   5530
      _StockProps     =   2
      Caption         =   "Watchlist -  (No Accounts) "
      Watchlist       =   ""
   End
End
Attribute VB_Name = "frmWatchlist"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'***********************************************************
' By using this material you agree to comply with the terms
' governing the MBTI systems and with the MBTI Site Terms and
' Conditions available for view at http://www.mbtrading.com/
' Copyright 2003 MB Trading, Inc. ALL RIGHTS RESERVED.
'***********************************************************
'
Option Explicit

Private Sub Form_Load()
    MbtWatchCtl.SetDefaultWatchlist
    SetCaption
    SerializeForm Me, False
End Sub

Private Sub Form_Unload(Cancel As Integer)
    SerializeForm Me, True
End Sub

Private Sub Form_Resize()
    MbtWatchCtl.Move 0, 0, ScaleWidth, ScaleHeight
End Sub

Private Sub SetCaption()
    Dim sWatchlist As String
    sWatchlist = MbtWatchCtl.Watchlist
' replaced this:
'    If Len(sWatchlist) Then
'        Caption = "Watchlist - " & sWatchlist
'    Else
'        Caption = "Watchlist"
'    End If
' with this: (on 3/10/03 - Phil)
    Caption = "Watchlist" & IIf(Len(sWatchlist), " - " & sWatchlist, "")
End Sub

Private Sub MbtWatchCtl_OnManualSymbolFocusChanged(ByVal Symbol As String)
    ' This is fired when the user has selected a position in the grid via the mouse.
    ' You may want to syncronize this symbol in some other view etc...
    Debug.Print "MbtWatchCtl_OnManualSymbolFocusChanged"
End Sub

Private Sub MbtWatchCtl_OnWatchlistChanged(ByVal NewList As String)
    ' This event is fired when user has chosen to display a different (or new) watchlist.
    Debug.Print "MbtWatchCtl_OnWatchlistChanged"
    SetCaption
End Sub
