Attribute VB_Name = "modMbtFids"
'***********************************************************
' By using this material you agree to comply with the terms
' governing the MBTI systems and with the MBTI Site Terms and
' Conditions available for view at http://www.mbtrading.com/
' Copyright 2003 MB Trading, Inc. ALL RIGHTS RESERVED.
'***********************************************************
'
Public Const HOSTVER_SDKTEST = 9 ' For testing purposes, generic login hostid for VB sdk test client

' Buy/Sell action values
Public Const VALUE_BUY = 10000
Public Const VALUE_SELL = 10001
Public Const VALUE_SELLSHT = 10002

' Time-in-force values
Public Const VALUE_GTC = 10008
Public Const VALUE_DAYPLUS = 10009
Public Const VALUE_IOC = 10010
Public Const VALUE_DAY = 10011
Public Const VALUE_SESSION = 10012

' Capacity values
Public Const VALUE_AGENCY = 10020
Public Const VALUE_PRINCIPAL = 10021

' Ordertype values
Public Const VALUE_LIMIT = 10030
Public Const VALUE_MARKET = 10031
Public Const VALUE_STOP_MARKET = 10032
Public Const VALUE_STOP_LIMIT = 10033
Public Const VALUE_TRAILING_STOP = 10034
Public Const VALUE_COND_ORD_MKT = 10035
Public Const VALUE_COND_ORD_LMT = 10036
Public Const VALUE_TTO_ORDER = 10037
Public Const VALUE_MARKET_OPEN = 10038
Public Const VALUE_MARKET_CLOSE = 10039
Public Const VALUE_RESERVE = 10040
Public Const VALUE_HIDDEN = 10041
Public Const VALUE_NORMAL = 10042
Public Const VALUE_DISCRETIONARY = 10043
Public Const VALUE_RSV_DISC = 10044
Public Const VALUE_PNP = 10045
Public Const VALUE_PART = 10046
Public Const VALUE_AON = 10047
Public Const VALUE_NOW = 10048
Public Const VALUE_THRU = 10049
Public Const VALUE_LIMIT_TTO = 10050
Public Const VALUE_MARKET_TTO = 10051
Public Const VALUE_RSV_TTO = 10052
Public Const VALUE_LIMIT_STOPMKT = 10064 ' 8/09/2005 - 10.13
Public Const VALUE_STOP_TRAIL = 10065 ' 8/09/2005 - 10.13
Public Const VALUE_RSV_PEGGED = 10066 ' 8/09/2005 - 10.13
Public Const VALUE_STOPLMT_TTO = 10067 ' 8/09/2005 - 10.13

' Alert severities
Public Const ALERT_VAL_NORMAL = 30000
Public Const ALERT_VAL_CRIT = 30001
Public Const ALERT_VAL_REINSTATE = 30002

' Alert types
Public Const ALERT_TYPE_ACCT = 30010
Public Const ALERT_TYPE_USER = 30011
Public Const ALERT_TYPE_ORDSRV = 30012
Public Const ALERT_TYPE_LOGOFF = 30013
Public Const ALERT_TYPE_INTERNAL = 30014

' Customer types
Public Const VALUE_DVP = 30020
Public Const VALUE_RETAIL = 30021
Public Const VALUE_DEMO = 30022
Public Const VALUE_ADMIN = 30023
Public Const VALUE_DVPADMIN = 30024

' Conditional order flags
Public Const VALUE_COND_GREAT_EQ = 30040
Public Const VALUE_COND_LESS_EQ = 30041

' QUOTERECORD lFlags bitfield values
Public Const VALUE_SHORTABLE = &H1
Public Const VALUE_MARGINABLE = &H2

' Account types
Public Const ACCT_TYPE_CASH = 1
Public Const ACCT_TYPE_MGN = 2
Public Const ACCT_TYPE_RESTRICT = 3
Public Const ACCT_TYPE_DVP = 6

' Template and trade perms flags
Public Const STF_EQUITIES = &H1
Public Const STF_OPTIONS = &H2
Public Const STF_FUTURES = &H4
Public Const STF_INDEXES = &H8
Public Const STF_SYMBOL_DETERMINANT = &H1000
Public Const STF_ALL = (STF_EQUITIES Or STF_OPTIONS Or STF_FUTURES Or STF_INDEXES Or STF_SYMBOL_DETERMINANT)

' Autocompletion options -- may be ORred together
Public Const ACO_NONE = 0
Public Const ACO_AUTOSUGGEST = &H1
Public Const ACO_AUTOAPPEND = &H2
Public Const ACO_USETAB = &H10
Public Const ACO_UPDOWNKEYDROPSLIST = &H20
