VERSION 5.00
Begin VB.Form frmLogin 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Login"
   ClientHeight    =   2940
   ClientLeft      =   2835
   ClientTop       =   3480
   ClientWidth     =   4110
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1737.049
   ScaleMode       =   0  'User
   ScaleWidth      =   3859.067
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.Frame frameLogin 
      Caption         =   "Log in"
      BeginProperty Font 
         Name            =   "Verdana"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2775
      Left            =   120
      TabIndex        =   5
      Top             =   60
      Width           =   3855
      Begin VB.TextBox txtPwd 
         Height          =   345
         IMEMode         =   3  'DISABLE
         Left            =   1665
         PasswordChar    =   "*"
         TabIndex        =   1
         Top             =   885
         Width           =   1725
      End
      Begin VB.CommandButton cmdCancel 
         Caption         =   "Cancel"
         Height          =   390
         Left            =   2235
         TabIndex        =   4
         Top             =   1980
         Width           =   1140
      End
      Begin VB.CommandButton cmdOK 
         Caption         =   "OK"
         Height          =   390
         Left            =   510
         TabIndex        =   3
         Top             =   1980
         Width           =   1140
      End
      Begin VB.TextBox txtUID 
         Height          =   345
         Left            =   1665
         TabIndex        =   0
         Top             =   480
         Width           =   1725
      End
      Begin VB.TextBox txtSDKID 
         Height          =   345
         IMEMode         =   3  'DISABLE
         Left            =   1680
         TabIndex        =   2
         Top             =   1320
         Width           =   645
      End
      Begin VB.Label lblLabels 
         Caption         =   "Password"
         Height          =   270
         Index           =   1
         Left            =   480
         TabIndex        =   8
         Top             =   900
         Width           =   1080
      End
      Begin VB.Label lblLabels 
         Caption         =   "User Name"
         Height          =   270
         Index           =   0
         Left            =   480
         TabIndex        =   7
         Top             =   510
         Width           =   1080
      End
      Begin VB.Label lblLabels 
         Caption         =   "SDK ID"
         Height          =   270
         Index           =   2
         Left            =   495
         TabIndex        =   6
         Top             =   1335
         Width           =   1080
      End
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "Please wait..."
      BeginProperty Font 
         Name            =   "Verdana"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   362
      TabIndex        =   9
      Top             =   1320
      Width           =   3408
   End
End
Attribute VB_Name = "frmLogin"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'Login fields
Private g_sUID As String
Private g_sPwd As String
Private g_lSDKID As Long
Private g_bGotDoLogin As Boolean

Private Sub Form_Load()
   Me.Show
   frmLogin.Caption = App.EXEName & " - Ver " & App.Major & "." & App.Minor
   frameLogin.Enabled = True
   frameLogin.Visible = True
   ' Instantiate ComMgr and grab objects off it
   Set frmMain.g_oComMgr = New MbtComMgr
   Set frmMain.g_oOrders = frmMain.g_oComMgr.OrderClient
   frmMain.g_oOrders.OnDemandMode = True
   Set frmMain.g_oQuotes = frmMain.g_oComMgr.Quotes
   
   ' Get rid of pesky Splash and misc. dialogs
   frmMain.g_oComMgr.EnableSplash (False)
   
   ' Fetch saved input from registry into text boxes
   g_lSDKID = CLng(GetSetting("checkLevelTwo", "Settings", "SDKID", "9"))
   g_sUID = UCase(GetSetting("checkLevelTwo", "Settings", "UID", ""))
   g_sPwd = GetSetting("checkLevelTwo", "Settings", "Pwd", "")
   txtSDKID.Text = g_lSDKID
   txtUID.Text = g_sUID
   txtPwd.Text = g_sPwd
   txtUID.SetFocus
   If Len(txtUID.Text) > 3 Then txtPwd.SetFocus
   If Len(txtPwd.Text) > 3 Then txtSDKID.SetFocus
   If Len(txtSDKID.Text) > 0 Then cmdOK.SetFocus

End Sub

Private Sub cmdOK_Click()
   GotOkClick
End Sub

Private Sub GotOkClick()
   g_lSDKID = txtSDKID.Text
   g_sUID = UCase(txtUID.Text)
   g_sPwd = txtPwd.Text
   If Len(g_sUID) > 3 And Len(g_sUID) < 16 And Len(g_sPwd) > 3 And Len(g_sPwd) < 16 Then
      g_bGotDoLogin = frmMain.g_oComMgr.DoLogin(g_lSDKID, g_sUID, g_sPwd, "")
      If g_bGotDoLogin Then
         frmMain.g_bGotOLS = False
         frameLogin.Visible = False
         ' On successful login, save our input and switch forms.
         SaveSetting "checkLevelTwo", "Settings", "SDKID", g_lSDKID
         SaveSetting "checkLevelTwo", "Settings", "UID", UCase(g_sUID)
         SaveSetting "checkLevelTwo", "Settings", "Pwd", g_sPwd
      Else
         Unload Me
         Exit Sub
      End If
   End If
End Sub

Private Sub cmdCancel_Click()
    Unload Me
End Sub

Private Sub txtUID_GotFocus()
   txtUID.SelLength = Len(txtUID.Text)
End Sub
Private Sub txtPwd_GotFocus()
   txtPwd.SelLength = Len(txtPwd.Text)
End Sub
Private Sub txtSDKID_GotFocus()
   txtSDKID.SelLength = Len(txtSDKID.Text)
End Sub

Private Sub txtUID_KeyUp(KeyCode As Integer, Shift As Integer)
   If KeyCode = 13 Then GotOkClick
End Sub
